gtk-0.12.0: Binding to the Gtk+ graphical user interface library.

Portability | portable (depends on GHC)
Stability | provisional
Maintainer | gtk2hs-users@lists.sourceforge.net

Graphics.UI.Gtk.Entry.EntryCompletion

Contents

- Detail
- Class Hierarchy
- Types
- Constructors
- Methods
- Attributes
- Signals
- Deprecated

Description

Completion functionality for `Entry`

- Module available since Gtk+ version 2.4

Synopsis

- data EntryCompletion
- class GObjectClass o => EntryCompletionClass o
- castToEntryCompletion :: GObjectClass obj => obj -> EntryCompletion
- gTypeEntryCompletion :: GType
- toEntryCompletion :: EntryCompletionClass o => o -> EntryCompletion
- entryCompletionNew :: IO EntryCompletion
- entryCompletionGetEntry :: EntryCompletion -> IO (Maybe Entry)
- entryCompletionSetModel :: TreeModelClass model => EntryCompletion -> Maybe model -> IO ()
- entryCompletionGetModel :: EntryCompletion -> IO (Maybe TreeModel)
- entryCompletionSetTextModel :: (TreeModelClass (model String), TypedTreeModelClass model) => EntryCompletion -> model String -> IO ()
- entryCompletionSetMatchFunc :: EntryCompletion -> (String -> TreeIter -> IO Bool) -> IO ()
- entryCompletionSetMinimumKeyLength :: EntryCompletion -> Int -> IO ()
- entryCompletionGetMinimumKeyLength :: EntryCompletion -> IO Int
- entryCompletionComplete :: EntryCompletion -> IO ()
- entryCompletionInsertActionText :: EntryCompletion -> Int -> String -> IO ()
- entryCompletionInsertActionMarkup :: EntryCompletion -> Int -> String -> IO ()
- entryCompletionDeleteAction :: EntryCompletion -> Int -> IO ()
- entryCompletionSetTextColumn :: EntryCompletion -> ColumnId row String -> IO ()
- entryCompletionInsertPrefix :: EntryCompletion -> IO ()
- entryCompletionGetTextColumn :: EntryCompletion -> IO (ColumnId row String)
- entryCompletionSetInlineCompletion :: EntryCompletion -> Bool -> IO ()
- entryCompletionGetInlineCompletion :: EntryCompletion -> IO Bool
- entryCompletionSetPopupCompletion :: EntryCompletion -> Bool -> IO ()
- entryCompletionGetPopupCompletion :: EntryCompletion -> IO Bool
- entryCompletionSetPopupSetWidth :: EntryCompletion -> Bool -> IO ()
- entryCompletionGetPopupSetWidth :: EntryCompletion -> IO Bool
- entryCompletionSetPopupSingleMatch :: EntryCompletion -> Bool -> IO ()
- entryCompletionGetPopupSingleMatch :: EntryCompletion -> IO Bool
- entryCompletionModel :: TreeModelClass model => ReadWriteAttr EntryCompletion (Maybe TreeModel) (Maybe model)
- entryCompletionMinimumKeyLength :: Attr EntryCompletion Int
- entryCompletionTextColumn :: Attr EntryCompletion (ColumnId row String)
- entryCompletionInlineCompletion :: Attr EntryCompletion Bool
- entryCompletionPopupCompletion :: Attr EntryCompletion Bool
- entryCompletionPopupSetWidth :: Attr EntryCompletion Bool
- entryCompletionPopupSingleMatch :: Attr EntryCompletion Bool
- insertPrefix :: EntryCompletionClass self => Signal self (String -> IO Bool)
- completionActionActivated :: EntryCompletionClass self => Signal self (Int -> IO ())
- matchSelected :: EntryCompletionClass self => Signal self (TreeModel -> TreeIter -> IO Bool)
- onInsertPrefix :: EntryCompletionClass self => self -> (String -> IO Bool) -> IO (ConnectId self)
- afterInsertPrefix :: EntryCompletionClass self => self -> (String -> IO Bool) -> IO (ConnectId self)
- onActionActivated :: EntryCompletionClass self => self -> (Int -> IO ()) -> IO (ConnectId self)
- afterActionActivated :: EntryCompletionClass self => self -> (Int -> IO ()) -> IO (ConnectId self)

# Detail

`EntryCompletion` is an auxiliary object to be used in conjunction with `Entry` to provide the completion functionality. It implements the `CellLayout` interface, to allow the user to add extra cells to the `TreeView` with completion matches.

"Completion functionality" means that when the user modifies the text in the entry, `EntryCompletion` checks which rows in the model match the current content of the entry, and displays a list of matches. By default, the matching is done by comparing the entry text case-insensitively against the text in a model (see `Graphics.UI.Gtk.Entry.entryCompletionSetTextModel`), but this can be overridden with a custom match function (see `entryCompletionSetMatchFunc`).

When the user selects a completion, the content of the entry is updated. By default, the content of the entry is replaced by the text column of the model, but this can be overridden by connecting to the `matchSelected` signal and updating the entry in the signal handler. Note that you should return `True` from the signal handler to suppress the default behaviour.

To add completion functionality to an entry, use `Graphics.UI.Gtk.Entry.Entry.entrySetCompletion`.

In addition to regular completion matches, which will be inserted into the entry when they are selected, `EntryCompletion` also allows to display "actions" in the popup window. Their appearance is similar to menu items, to differentiate them clearly from completion strings. When an action is selected, the `completionActionActivated` signal is emitted.

# Class Hierarchy

     | GObject
     | +----EntryCompletion

# Types

data EntryCompletion

Instances

Eq EntryCompletion |
Ord EntryCompletion |
GObjectClass EntryCompletion |
EntryCompletionClass EntryCompletion |
CellLayoutClass EntryCompletion |

class GObjectClass o => EntryCompletionClass o

Instances

EntryCompletionClass EntryCompletion |

castToEntryCompletion :: GObjectClass obj => obj -> EntryCompletion

gTypeEntryCompletion :: GType

toEntryCompletion :: EntryCompletionClass o => o -> EntryCompletion

# Constructors

entryCompletionNew :: IO EntryCompletion

Creates a new `EntryCompletion` object.

# Methods

entryCompletionGetEntry

Arguments

:: EntryCompletion |
-> IO (Maybe Entry) | returns the entry `completion` has been attached to.

Gets the entry `completion` has been attached to.

entryCompletionSetModel

Arguments

:: TreeModelClass model |
=> EntryCompletion |
-> Maybe model | `model` - The `TreeModel`.
-> IO () |

Sets the model for a `EntryCompletion`. If `completion` already has a model set, it will remove it before setting the new model. If model is `Nothing`, then it will unset the model.

entryCompletionGetModel

Arguments

:: EntryCompletion |
-> IO (Maybe TreeModel) | returns A `TreeModel`, or `Nothing` if none is currently being used.

Returns the model the `EntryCompletion` is using as data source. Returns `Nothing` if the model is unset.

entryCompletionSetTextModel

Arguments

:: (TreeModelClass (model String), TypedTreeModelClass model) |

=> EntryCompletion

    completion

-> model String | the model containing `String`s
-> IO () |

Convenience function for setting up the most used case of this code: a completion list with just strings. This function will set up `completion` to have a list displaying all (and just) strings in the completion list, and to get those strings from `model`. This functions creates and adds a `CellRendererText` which retrieves its content from the given model.

entryCompletionSetMatchFunc :: EntryCompletion -> (String -> TreeIter -> IO Bool) -> IO ()

Sets the match function for `completion` to be `func`. The match function is used to determine if a row should or should not be in the completion list.

- The passed-in function decides whether the row indicated by the `TreeIter` matches a given key, and should be displayed as a possible completion for key. Note that the key is normalized and case-folded. Normalization will standardizing such issues as whether a character with an accent is represented as a base character and combining accent or as a single precomposed character. If this is not appropriate you can extract the original text from the entry.

entryCompletionSetMinimumKeyLength

Arguments

:: EntryCompletion |
-> Int | `length` - The minimum length of the key in order to start completing.
-> IO () |

Requires the length of the search key for `completion` to be at least `length`. This is useful for long lists, where completing using a small key takes a lot of time and will come up with meaningless results anyway (ie, a too large dataset).

entryCompletionGetMinimumKeyLength

Arguments

:: EntryCompletion |
-> IO Int | returns The currently used minimum key length.

Returns the minimum key length as set for `completion`.

entryCompletionComplete :: EntryCompletion -> IO ()

Requests a completion operation, or in other words a refiltering of the current list with completions, using the current key. The completion list view will be updated accordingly.

entryCompletionInsertActionText

Arguments

:: EntryCompletion |
-> Int | `index` - The index of the item to insert.
-> String | `text` - Text of the item to insert.
-> IO () |

Inserts an action in `completion`'s action item list at position `index` with text `text`. If you want the action item to have markup, use `entryCompletionInsertActionMarkup`.

entryCompletionInsertActionMarkup

Arguments

:: EntryCompletion |
-> Int | `index` - The index of the item to insert.
-> String | `markup` - Markup of the item to insert.
-> IO () |

Inserts an action in `completion`'s action item list at position `index` with markup `markup`.

entryCompletionDeleteAction

Arguments

:: EntryCompletion |
-> Int | `index` - The index of the item to Delete.
-> IO () |

Deletes the action at `index` from `completion`'s action list.

entryCompletionSetTextColumn

Arguments

:: EntryCompletion |
-> ColumnId row String | `column` - The column in the model of `completion` to get strings from.
-> IO () |

Convenience function for setting up the most used case of this code: a completion list with just strings. This function will set up `completion` to have a list displaying all (and just) strings in the completion list, and to get those strings from `column` in the model of `completion`.

This functions creates and adds a `CellRendererText` for the selected column.

entryCompletionInsertPrefix :: EntryCompletion -> IO ()

Requests a prefix insertion.

- Available since Gtk+ version 2.6

entryCompletionGetTextColumn

Arguments

:: EntryCompletion |
-> IO (ColumnId row String) | returns the column containing the strings

Returns the column in the model of the completion to get strings from.

- Available since Gtk+ version 2.6

entryCompletionSetInlineCompletion

Arguments

:: EntryCompletion |
-> Bool | `inlineCompletion` - `True` to do inline completion
-> IO () |

Sets whether the common prefix of the possible completions should be automatically inserted in the entry.

- Available since Gtk+ version 2.6

entryCompletionGetInlineCompletion

Arguments

:: EntryCompletion |
-> IO Bool | returns `True` if inline completion is turned on

Returns whether the common prefix of the possible completions should be automatically inserted in the entry.

- Available since Gtk+ version 2.6

entryCompletionSetPopupCompletion

Arguments

:: EntryCompletion |
-> Bool | `popupCompletion` - `True` to do popup completion
-> IO () |

Sets whether the completions should be presented in a popup window.

- Available since Gtk+ version 2.6

entryCompletionGetPopupCompletion

Arguments

:: EntryCompletion |
-> IO Bool | returns `True` if popup completion is turned on

Returns whether the completions should be presented in a popup window.

- Available since Gtk+ version 2.6

entryCompletionSetPopupSetWidth

Arguments

:: EntryCompletion |
-> Bool | `popupSetWidth` - `True` to make the width of the popup the same as the entry
-> IO () |

Sets whether the completion popup window will be resized to be the same width as the entry.

- Available since Gtk+ version 2.8

entryCompletionGetPopupSetWidth

Arguments

:: EntryCompletion |
-> IO Bool | returns `True` if the popup window will be resized to the width of the entry

Returns whether the completion popup window will be resized to the width of the entry.

- Available since Gtk+ version 2.8

entryCompletionSetPopupSingleMatch

Arguments

:: EntryCompletion |
-> Bool | `popupSingleMatch` - `True` if the popup should appear even for a single match
-> IO () |

Sets whether the completion popup window will appear even if there is only a single match. You may want to set this to `False` if you are using inline completion.

- Available since Gtk+ version 2.8

entryCompletionGetPopupSingleMatch

Arguments

:: EntryCompletion |
-> IO Bool | returns `True` if the popup window will appear regardless of the number of matches.

Returns whether the completion popup window will appear even if there is only a single match.

- Available since Gtk+ version 2.8

# Attributes

entryCompletionModel :: TreeModelClass model => ReadWriteAttr EntryCompletion (Maybe TreeModel) (Maybe model)

The model to find matches in.

entryCompletionMinimumKeyLength :: Attr EntryCompletion Int

Minimum length of the search key in order to look up matches.

Allowed values: >= 0

Default value: 1

entryCompletionTextColumn :: Attr EntryCompletion (ColumnId row String)

The column of the model containing the strings.

Default value: `Graphics.UI.Gtk.ModelView.CustomStore.invalidColumnId`

entryCompletionInlineCompletion :: Attr EntryCompletion Bool

Determines whether the common prefix of the possible completions should be inserted automatically in the entry. Note that this requires text-column to be set, even if you are using a custom match function.

Default value: `False`

entryCompletionPopupCompletion :: Attr EntryCompletion Bool

Determines whether the possible completions should be shown in a popup window.

Default value: `True`

entryCompletionPopupSetWidth :: Attr EntryCompletion Bool

Determines whether the completions popup window will be resized to the width of the entry.

Default value: `True`

entryCompletionPopupSingleMatch :: Attr EntryCompletion Bool

Determines whether the completions popup window will shown for a single possible completion. You probably want to set this to `False` if you are using inline completion.

Default value: `True`

# Signals

insertPrefix :: EntryCompletionClass self => Signal self (String -> IO Bool)

Gets emitted when the inline autocompletion is triggered. The default behaviour is to make the entry display the whole prefix and select the newly inserted part.

Applications may connect to this signal in order to insert only a smaller part of the `prefix` into the entry - e.g. the entry used in the `FileChooser` inserts only the part of the prefix up to the next '/'.

- Available since Gtk+ version 2.6

completionActionActivated :: EntryCompletionClass self => Signal self (Int -> IO ())

Gets emitted when an action is activated.

matchSelected :: EntryCompletionClass self => Signal self (TreeModel -> TreeIter -> IO Bool)

Gets emitted when a match from the list is selected. The default behaviour is to replace the contents of the entry with the contents of the text column in the row pointed to by `iter`.

# Deprecated

onInsertPrefix :: EntryCompletionClass self => self -> (String -> IO Bool) -> IO (ConnectId self)

afterInsertPrefix :: EntryCompletionClass self => self -> (String -> IO Bool) -> IO (ConnectId self)

Gets emitted when the inline autocompletion is triggered. The default behaviour is to make the entry display the whole prefix and select the newly inserted part.

Applications may connect to this signal in order to insert only a smaller part of the `prefix` into the entry - e.g. the entry used in the `FileChooser` inserts only the part of the prefix up to the next '/'.

onActionActivated :: EntryCompletionClass self => self -> (Int -> IO ()) -> IO (ConnectId self)

afterActionActivated :: EntryCompletionClass self => self -> (Int -> IO ()) -> IO (ConnectId self)

Gets emitted when an action is activated.